;----------------------------------------------------------------
;
;	Visdom Demo - Part I: Hotline
;
;	(c) 12-04-1989 by JL
;	(r) 20/22-01-1991 by JL
;	(r) 27-03-1991 by JL
;	(r) 22-02-2012 by JAC!, pressing any key now leaves part 1 instead of pressing SELECT
;	(r) 07-03-2012 by JAC!, NTSC color mapping included
;
;----------------------------------------------------------------

hot_main_start
	jsr init_hotline

	jsr hot_pmein
	lda #75
	jsr wait
	jsr hot_topon
	lda #50
	jsr wait
	jsr hot_scron

hot_main_loop
	lda $d01f
	and #7
	cmp #7
	bne hot_main_exit
	lda $d20f
	and #12
	cmp #12
	bne hot_main_exit

	lda hot_topcolor
	beq hot_main_loop

	jsr hot_topoff
	jsr hot_topon
	lda #0
	sta hot_topcolor
	jmp hot_main_loop

hot_main_exit
	jsr hot_fade
	rts
;----------------------------------------------------------------
init_hotline
	sei
	ldx #0
	stx $d40e
	stx $d400
	dex
	lda #$fe
	sta $d301
	set $d402,hot_dl
	lda #15
	sta $d404
	lda #>pm
	sta $d407
	lda #$e4
	jsr map_palette
	sta $d012
	sta $d014
	lda #$e8
	jsr map_palette
	sta $d013
	sta $d015
	lda #$1
	sta $d008
	sta $d009
	sta $d00a
	sta $d00b
	lda #$21
	sta $d01b
	lda #3
	sta $d01d

	lda #0
	sta dliup
	sta cnt

	sta hot_topcolor
	sta hot_topcolors+0
	sta hot_topcolors+1
	sta hot_topcolors+2

	sta hot_barcnt
	sta hot_scrflg
	sta hot_scrhold

	sta hot_botcolor

	ldy #49
init_hotline1
	sta ctab,y
	dey
	bpl init_hotline1

	ldy #0
init_hotline2
	sta pm+$400,y
	sta pm+$500,y
	sta pm+$600,y
	sta pm+$700,y
	iny
	bne init_hotline2

	lda #160
	ldy #47
init_hotline3
	sta hot_topline+400,y
	dey
	bpl init_hotline3

	set tp,hot_textbegin	;convert_ASCII
	ldy #0
init_hotline_conv
	lda (tp),y
	beq init_hotline_conv2
	bmi init_hotline_conv1	;scroll_code
	cmp #$60
	bcc init_hotline_conv1
	and #$5f
	sta (tp),y
init_hotline_conv1
	dic tp
	jmp init_hotline_conv
init_hotline_conv2
	set tp,hot_text		;text_pointer
	set $fffa,hot_nmi
	lda #$c0
	sta $d40e
	lda $d40b
	bne *-3
	lda #$3e
	sta $d400
	rts

;----------------------------------------------------------------
hot_dli	lda dliup
	beq hot_dlia
	cmp #1
	beq hot_dlib
	cmp #2
	beq hot_dlic
	cmp #3
	beq hot_dlid
	bne hot_dlie

hot_dlia
	lda #>hotchr2
	sta $d40a
	sta $d409
	jmp hot_dlix

hot_dlib
	lda #0
	sta $d017
	sta $d018
	jmp hot_dlix

hot_dlic
	lda cnt
	jmp hot_dlid1
hot_dlid
	lda cnt
	eor #255
hot_dlid1
	lsr
	tay
	ldx #7
hot_dlid2
	tya
	and #15
	asl
	clc
	adc #90
	sta $d40a
	sta $d000
	sta $d001
	adc #32
	sta $d002
	sta $d003
	iny
	dex
	bpl hot_dlid2
	jmp hot_dlix

hot_dlie
	ldx #49
	sta $d40a
	sta $d40a
	sta $d40a
hot_dlie1
	lda ctab,x
	sta $d40a
	sta $d018
	sta $d01a
	dex
	bpl hot_dlie1
	lda #0
	sta $d01a
	sta $d01a
	lda hot_botcolor
	sta $d018

hot_dlix
	inc dliup
	jmp hot_nmiend

;----------------------------------------------------------------

hot_pmein
	ldy #$6d
	jsr hot_pmein1
	ldy #$85
hot_pmein1
	lda #50
	jsr wait
	ldx #6
hot_pmein2
	lda #$99
	sta pm+$400,y
	sta pm+$600,y
	lda #$7e
	sta pm+$500,y
	sta pm+$700,y
	lda #8
	jsr wait
	iny
	dex
	bpl hot_pmein2
	rts

;----------------------------------------------------------------

hot_topon
	ldx #0
hot_topon1
	lda #4
	jsr wait
	lda topftab,x
	ora hot_topcolor
	sta hot_topcolors+0
	lda topftab+13,x
	ora hot_topcolor
	sta hot_topcolors+1
	lda topftab+26,x
	ora hot_topcolor
	sta hot_topcolors+2
	inx
	cpx #13
	bne hot_topon1
	rts

;----------------------------------------------------------------

hot_scron
	ldx #49
hot_scron1
	lda #1
	jsr wait
	lda ctab,x
	cmp textftab,x
	beq hot_scron2
	sta ctab,x
	inc ctab,x
	jmp hot_scron1
hot_scron2
	dex
	bpl hot_scron1
	lda #25
	jsr wait
	lda #4
	sta hot_botcolor
	lda #50
	jsr wait
	lda #1
	sta hot_scrflg
	rts

;----------------------------------------------------------------

hot_topoff
	ldx #2
hot_topoff1
	lda hot_topcolors,x
	and #$0f	;maximum?
	cmp #$0f
	beq hot_topoff2
	inc hot_topcolors,x
hot_topoff2
	dex
	bpl hot_topoff1
	lda #2
	jsr wait
	lda hot_topcolors+2
	and #$0f
	cmp #$0f
	bne hot_topoff

	ldy hot_topcolors
	ldx #15
hot_topoff3
	sty hot_topcolors+0
	sty hot_topcolors+1
	sty hot_topcolors+2
	dey
	lda #2
	jsr wait
	dex
	bpl hot_topoff3
	lda #0
	sta hot_topcolors+0
	sta hot_topcolors+1
	sta hot_topcolors+2
	lda #25
	jsr wait
	rts

;----------------------------------------------------------------
hot_fade
	ldx #0
hot_fade1
	lda #0
	sta ctab,x
	lda #1
	jsr wait
	inx
	cpx #50
	bne hot_fade1
	jsr hot_topoff
hot_fade2
	lda hot_botcolor
	bne hot_fade2
	sta hot_scrflg
	lda #25
	jsr wait
	ldx #$28
hot_fade3
	lda #0
	sta pm+$46d,x
	sta pm+$56d,x
	sta pm+$66d,x
	sta pm+$76d,x
	lda #1
	jsr wait
	dex
	bpl hot_fade3
	lda #25
	jsr wait
	rts

;----------------------------------------------------------------

hot_nmi	sta irqa	;main_nm
	stx irqx
	sty irqy
	bit $d40f
	bpl hot_vbi
	jmp hot_dli

hot_nmiend
	lda irqa
	ldx irqx
	ldy irqy
	rti

;----------------------------------------------------------------

hot_vbi	lda #>hotchr1
	sta $d409
	lda hot_topcolors
	sta $d016
	lda hot_topcolors+1
	sta $d017
	lda hot_topcolors+2
	sta $d018
	lda #0
	sta dliup

	lda hot_scrflg
	bne *+5
	jmp hot_vbix
	lda hot_scrhold
	beq hot_vbi0
	dec hot_scrhold
	jmp hot_vbi4a
hot_vbi0
	lda cnt
	eor #7
	ora #12
	sta $d404
	and #3
	cmp #3
	bne hot_vbi4a
	ldx #0
hot_vbi1
	lda hot_topline+401,x
	sta hot_topline+400,x
	inx
	cpx #40
	bne hot_vbi1
hot_vbi2
	ldy #0		;get_chr
	lda (tp),y
	bne hot_vbi3
	set tp,hot_text	;restart_text
	jmp hot_vbi2
hot_vbi3
	bpl hot_vbi4	;command_found
	iny
	lda (tp),y
	cmp #$fc	;hold_on
	bne hot_vbi3a
	sta hot_scrhold
	jmp hot_vbi3b
hot_vbi3a
	jsr map_palette
	sta hot_topcolor
hot_vbi3b
	add tp,2
	jmp hot_vbi2
hot_vbi4
	sta hot_topline+440
	dic tp

hot_vbi4a
	lda hot_barcnt
	bne hot_vbi6
	lda hot_bardir
	eor #1
	sta hot_bardir
hot_vbi5
	lda $d20a	;New_random_scroll_color,no_NTSC_mapping_required
	and #$f0
	beq hot_vbi5
	cmp hot_barcolor
	beq hot_vbi5
	sta hot_barcolor

hot_vbi6
	lda hot_barcnt
	cmp #50
	bcs hot_vbi9
	ldx hot_bardir
	bne hot_vbi7
	lda #49
	sec
	sbc hot_barcnt
hot_vbi7
	tax
	lda ctab,x
	and #$0f
	beq hot_vbi8
	ora hot_barcolor
hot_vbi8
	sta ctab,x
hot_vbi9
	inc hot_barcnt

	lda cnt
	cmp #$08
	bcc hot_vbix
	cmp #$48
	bcs hot_vbix
	and #31
	cmp #16
	bcc *+4
	eor #31
	sta hot_botcolor

hot_vbix
	inc cnt
	jsr play_sound
	jmp hot_nmiend

hot_dl	.byte $70,$70,$30,$44
	.word hot_topline
	.byte $04,$04,$04,$04,$04,$84
	.byte $04,$f0,$f0,$02,$70,$f0
	.byte $02,$70,$f0,$70,$70,$70
	.byte $12,$70,$70,$70,$70,$70
	.byte $02,$41
	.word hot_dl

topftab	.byte 0,2,4,6,8,10,12,14,14,14,14,14,14
	.byte 0,2,4,6,8,10,12,14,12,10,8,8,8
	.byte 0,2,4,6,8,10,12,14,12,10,8,6,4

textftab
	.byte 0,2
	.byte 0,2,4
	.byte 0,2,4,6
	.byte 0,2,4,6,8
	.byte 0,2,4,6,8,10
	.byte 0,4,8,10,14,14,10,8,4,0
	.byte 10,8,6,4,2,0
	.byte 8,6,4,2,0
	.byte 6,4,2,0
	.byte 4,2,0
	.byte 2,0

hot_topcolor	.byte 0		;top_color_without_brightess
hot_topcolors	.byte 0,0,0	;top_colors_with_brightness

hot_barcnt	.byte 0		;scroll_bars_effect
hot_bardir	.byte 0
hot_barcolor	.byte 0

hot_scrflg	.byte 0		;scroll_bars_counters
hot_scrhold	.byte 0

hot_botcolor	.byte 0		;bottom_color

hot_topline
	.byte $00,$00,$01,$02,$02,$03,$04,$05
	.byte $02,$06,$07,$02,$02,$02,$02,$02
	.byte $02,$02,$02,$02,$02,$02,$08,$09
	.byte $02,$02,$0a,$0b,$02,$02,$02,$02
	.byte $02,$02,$02,$03,$00,$00,$00,$00
	.byte $00,$00,$0c,$0d,$0e,$0f,$10,$11
	.byte $12,$13,$14,$15,$16,$17,$12,$0d
	.byte $0e,$15,$16,$17,$12,$0d,$18,$19
	.byte $1a,$1b,$1c,$1d,$0e,$15,$16,$17
	.byte $12,$0d,$0e,$0f,$00,$00,$00,$00
	.byte $00,$00,$0c,$1e,$1f,$20,$21,$22
	.byte $23,$24,$25,$26,$27,$28,$29,$2a
	.byte $2b,$2c,$2d,$2e,$2f,$1e,$30,$31
	.byte $32,$33,$34,$35,$1f,$36,$37,$38
	.byte $39,$3a,$3b,$3c,$00,$00,$00,$00
	.byte $00,$00,$0c,$26,$3d,$3e,$23,$1e
	.byte $1f,$3f,$40,$3e,$41,$10,$42,$26
	.byte $43,$44,$23,$45,$46,$26,$47,$31
	.byte $23,$1e,$34,$48,$3d,$13,$49,$1e
	.byte $4a,$4b,$3d,$4c,$00,$00,$00,$00
	.byte $00,$00,$0c,$3e,$23,$4d,$4e,$4f
	.byte $3d,$13,$49,$1e,$4a,$10,$50,$3e
	.byte $51,$52,$1f,$53,$54,$3e,$55,$31
	.byte $1f,$26,$34,$22,$23,$24,$25,$26
	.byte $56,$57,$58,$59,$00,$00,$00,$00
	.byte $00,$00,$0c,$1e,$1f,$0f,$10,$22
	.byte $23,$5a,$5b,$5c,$5d,$5e,$5f,$1e
	.byte $60,$61,$3d,$4c,$62,$1e,$63,$64
	.byte $65,$66,$67,$68,$1f,$3f,$40,$3e
	.byte $69,$6a,$6b,$6c,$6d,$00,$00,$00
	.byte $00,$00,$0c,$6e,$6f,$0f,$10,$70
	.byte $71,$6e,$6f,$72,$73,$74,$71,$6e
	.byte $75,$76,$73,$77,$78,$6e,$6f,$72
	.byte $73,$74,$71,$6e,$6f,$79,$7a,$74
	.byte $71,$6e,$6f,$72,$7b,$00,$00,$00
	.byte $00,$00,$01,$02,$02,$03,$04,$05
	.byte $02,$02,$02,$02,$02,$02,$02,$02
	.byte $06,$07,$02,$08,$09,$02,$02,$02
	.byte $02,$02,$02,$02,$02,$06,$0a,$02
	.byte $02,$02,$02,$02,$0b,$00,$00,$00

hot_textbegin
	.byte "            had the idea and            "
	.byte "            jaco adapted it!            "
	.byte "                                                "
	.byte "dedicated by jl to the freaks of hotline"

hot_text
	.byte " hello freaks !! schaut mal kurz da oben hin ... "
	.byte "                ",$80,$30,"                      "
	.byte "so na dann erst einmal herzlich wilkommen zu einem neuen "
	.byte "demo von mir ! ",$80,$10
	.byte "mein name ist peter dell ... alias ",quote,"jacomo leopardi",quote," .... "
	.byte "und ich habe dieses demo im februar 1991 fuer "ppp" "
	.byte "fertiggestellt.", $80,$60
	.byte "                         "
	.byte "es ist den leuten von ",quote,"hotline",quote," gewidmet,die die vorlage "
	.byte "hierzu 1989 auf einem 64er programmiert haben. "
	.byte "ich liebe die version,vor allem den ",quote,"smooth criminal",quote," "
	.byte "sound von charles deenen ... den hab ich 1000 mal gehoert! "
	.byte $80,$c0
	.byte "der sound fuer dieses demo stammt aus einer alten ausgabe "
	.byte "von ",quote,"ck",quote," und weil er deshalb nirgends mehr zu kriegen ist "
	.byte "habe ich ihn umgeschrieben und eingebaut ... "
	.byte $80,$70,"denn er ist der beste,den ich je auf einem xl "
	.byte "gehoert habe!  somit ein riesengrosses hallo an "
	.byte quote,"spueli-soft",quote,",die ihn komponiert hat !! "
	.byte "und dann auch hier noch ein aufruf ... wer musik auf dem xl "
	.byte "schreiben kann oder gerne programmiert , der wende sich "
	.byte "bitte an mich ... "
	.byte "       peter dell  in der klink 32      ",$80,$fc
	.byte "       6601 heusweiler west-germany     ",$80,$fc
	.byte " oder            telefon (06806) 77895         ",$80,$fc
	.byte $80,$50," dann zum abschluss noch die greetings: "
	.byte "gsp ... dr erwin ... cdam .... paul ... hotline ... "
	.byte "red sector inc ... und alle,denen die sach hier gefaellt!"
	.byte $80,$30,"       mit start wird das demo neu gestartet,"
	.byte "mit select geht es weiter ....                     "
	.byte "jl in 91                                         ",0

;----------------------------------------------------------------

end_part1

